/*
*********************************************************************************************************
*											        eBase
*
*
*
*						        (c) Copyright 2006-2010, AW China
*											All	Rights Reserved
*
* File    	: 	egon_drv_common_inc.h
* Date	:	2010-09-25
* By      	: 	holigun
* Version 	: 	V1.00
*********************************************************************************************************
*/
#ifndef	_WBOOT_MBR_H_
#define	_WBOOT_MBR_H_


#define     DOWNLOAD_MAP_NAME   "dlinfo.fex"
#define     SUNXI_MBR_NAME      "sunxi_mbr.fex"
/* MBR       */
#define     MBR_SIZE			    (16 * 1024)
#define     DL_SIZE					(16 * 1024)
#define   	MBR_MAGIC			    "softw411"
#define     MBR_MAX_PART_COUNT		120
#define     MBR_COPY_NUM          	4    //mbrı
#define     MBR_RESERVED          	(MBR_SIZE - 32 - (MBR_MAX_PART_COUNT * sizeof(PARTITION)))   //mbrĿռ
#define     DL_RESERVED           	(DL_SIZE - 32 - (MBR_MAX_PART_COUNT * sizeof(dl_one_part_info)))

/* partition information */
typedef struct sunxi_partition_t
{
	unsigned  int       addrhi;				//ʼַ, Ϊλ
	unsigned  int       addrlo;				//
	unsigned  int       lenhi;				//
	unsigned  int       lenlo;				//
	unsigned  char      classname[16];		//豸
	unsigned  char      name[16];			//豸
	unsigned  int       user_type;          //û
	unsigned  int       keydata;            //ؼݣҪʧ
	unsigned  int       ro;                 //д
	unsigned  char      reserved[68];		//ݣƥϢ128ֽ
}__attribute__ ((packed))PARTITION;

/* mbr information */
typedef struct sunxi_mbr
{
	unsigned  int       crc32;				        // crc 1k - 4
	unsigned  int       version;			        // 汾Ϣ 0x00000100
	unsigned  char 	    magic[8];			        //"softw411"
	unsigned  int 	    copy;				        //
	unsigned  int 	    index;				        //ڼMBR
	unsigned  int       PartCount;			        //
	unsigned  int       stamp[1];					//
	PARTITION           array[MBR_MAX_PART_COUNT];	//
	unsigned  char      res[MBR_RESERVED];
}__attribute__ ((packed)) MBR;

typedef struct tag_one_part_info
{
	unsigned  char      name[16];           //д豸
	unsigned  int       addrhi;             //дĸߵַλ
	unsigned  int       addrlo;             //дĵ͵ַλ
	unsigned  int       lenhi;				//дĳȣ32λλ
	unsigned  int       lenlo;				//дĳȣ32λλ
	unsigned  char      dl_filename[16];    //дļƣȹ̶16ֽ
	unsigned  char      vf_filename[16];    //дУļƣȹ̶16ֽ
	unsigned  int       encrypt;            //дǷм 0:   1
	unsigned  int       verify;             //дǷУ 0:У 1У
}__attribute__ ((packed)) dl_one_part_info;

//дϢ
typedef struct tag_download_info
{
	unsigned  int       crc32;				        		        //crc
	unsigned  int       version;                                    //汾  0x00000101
	unsigned  char 	    magic[8];			        		        //"softw311"
	unsigned  int       download_count;             		        //Ҫдķ
	unsigned  int       stamp[3];									//
	dl_one_part_info	one_part_info[MBR_MAX_PART_COUNT];	//дϢ
	unsigned  char      res[DL_RESERVED];
}
__attribute__ ((packed)) download_info;


//׼Ϣ
#pragma pack(push, 1)
typedef struct tag_part_info_stand
{
	char 				indicator;			//ʾ÷Ƿǻ
	char				start_head;			//ʼĴͷ
	short				start_sector:6;		//ʼ
	short				start_cylinder:10;	//ʼ
	char				part_type;			//			00H:ûָ  01H:DOS12	02H:xenix	04H:DOS16 05H:չ	06H:FAT16
											//					07H:NTFS	  0BH:FAT32
	char				end_head;			//Ĵͷ
	short				end_sector:6;		//
	short				end_cylinder:10;	//
	//int					start_sectors;		//ʼǰ˵Ӳ̵ĸ߼
	//int					total_sectors;		//е
	short				start_sectorl;
	short				start_sectorh;
	short				total_sectorsl;
	short				total_sectorsh;
}
part_info_stand;
#pragma pack(pop)
//׼MBR
#pragma pack(push, 1)
typedef struct tag_mbr_stand
{
	char				mbr[0x89];			//¼
	char				err_info[0x135];	//Ϣ
	part_info_stand		part_info[4];		//
	short				end_flag;			//̶ֵ 0x55aa
}
mbr_stand;
#pragma pack(pop)


//̬ݴʽ
typedef struct tag_dynamic_data_form
{
	char  name[16];
	int   datasize;
	int   usedsize;
}
dynamic_data_form;

typedef struct tag_dynamic_boot_head
{
	char  magic[8];
	int   count;
	int   size;
}
dynamic_boot_head;

#endif	//_WBOOT_MBR_H_

/* end of _WBOOT_MBR_H_ */


